package com.yuandian.dataflow.statemachine;

import java.io.ByteArrayInputStream;
import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutput;
import java.io.ObjectOutputStream;
import java.io.Serializable;

import org.apache.ratis.protocol.Message;
import org.apache.ratis.thirdparty.com.google.protobuf.ByteString;
import org.apache.ratis.util.MemoizedSupplier;
import org.apache.ratis.util.StringUtils;

import lombok.Getter;
import lombok.Setter;
import lombok.extern.slf4j.Slf4j;

@Slf4j
@Getter
@Setter
public class Operate implements Message,Serializable {

    private int a = 2;

    public static enum OperateType {
        /**
         * 同步WorkerState状态. 
         */
        PUT_WORKERSTATE, 

        /**
         * 分配packets
         */
        ALLOCATE_PACKETS, 

 
        /**
         *  暂无想法
         */
        REMOVE;
    }

    private OperateType type;
    private Object value;
 
    public Object getValue() {
        return  this.value;
    };

    public   void setValue(Object value) {
        this.value = value;
        return;
    };


    public Operate(OperateType t) {
        this.type = t;
    }

    public Operate(OperateType t, Object value) {
        this.type = t;
        this.value = value;
    }

    public Message toMessage() {
        try {
 
            var output = ByteString.newOutput();
            var outputStream = new ObjectOutputStream(output);
            outputStream.writeObject( this);
            outputStream.close();
            output.close();


            // var inBytes = new ByteArrayInputStream( output.toByteString().toByteArray() );
            // var inObject = new ObjectInputStream(inBytes);
   
            
            // var a = (Operate)inObject.readObject();
            // log.info("applyTransaction {}", a);


            return Message.valueOf(output.toByteString());
        } catch (IOException  e) {
            e.printStackTrace();
        }
        return null;
    }

    @Override
    public ByteString getContent() {
        try {
 
            var output = ByteString.newOutput();
            var outputStream = new ObjectOutputStream(output);
            outputStream.writeObject( this);
            outputStream.close();
            output.close();


            // var inBytes = new ByteArrayInputStream( output.toByteString().toByteArray() );
            // var inObject = new ObjectInputStream(inBytes);
   
            
            // var a = (Operate)inObject.readObject();
            // log.info("applyTransaction {}", a);


            return  output.toByteString();
        } catch (IOException  e) {
            e.printStackTrace();
        }
        return null;
    }

 
 

 

 
}
